freedombone-app-xmpp 20KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # XMPP functions
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2014-2016 Bob Mottram <bob@robotics.uk.to>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. VARIANTS='full chat'
  31. # Directory where XMPP settings are stored
  32. XMPP_DIRECTORY="/var/lib/prosody"
  33. XMPP_PASSWORD=
  34. XMPP_CIPHERS='"EDH+CAMELLIA:EDH+aRSA:EECDH+aRSA+AESGCM:EECDH+aRSA+SHA256:EECDH:+CAMELLIA128:+AES128:+SSLv3:!aNULL:!eNULL:!LOW:!3DES:!MD5:!EXP:!PSK:!DSS:!RC4:!SEED:!IDEA:!ECDSA:kEDH:CAMELLIA128-SHA:AES128-SHA"'
  35. XMPP_ECC_CURVE='"secp384r1"'
  36. function run_client_xmpp {
  37. torify profanity
  38. }
  39. function install_interactive_xmpp {
  40. echo -n ''
  41. }
  42. function change_password_xmpp {
  43. echo -n ''
  44. }
  45. function reconfigure_xmpp {
  46. echo -n ''
  47. }
  48. function update_prosody_modules {
  49. if [ ! -d $INSTALL_DIR/prosody-modules ]; then
  50. return
  51. fi
  52. if [ ! -d /usr/lib/prosody ]; then
  53. return
  54. fi
  55. cd $INSTALL_DIR/prosody-modules
  56. hg pull
  57. hg update
  58. # support onion addresses
  59. if [ -f $INSTALL_DIR/prosody-modules/mod_onions/mod_onions.lua ]; then
  60. cp $INSTALL_DIR/prosody-modules/mod_onions/mod_onions.lua /usr/lib/prosody/modules/mod_onions.lua
  61. fi
  62. # XEP-0313 message archive management
  63. # https://modules.prosody.im/mod_mam.html
  64. # Allows you to download your previous messages onto a new client
  65. # This only applies if you are not using forward secret crypto
  66. # such as OTR or OMEMO (eg. OpenPGP)
  67. if [ -d $INSTALL_DIR/prosody-modules/mod_mam ]; then
  68. cp $INSTALL_DIR/prosody-modules/mod_mam/*.lua /usr/lib/prosody/modules
  69. fi
  70. # XEP-0352 Client State Indication
  71. # Notifies the server if the app is in the background or not
  72. if [ -d $INSTALL_DIR/prosody-modules/mod_csi ]; then
  73. cp $INSTALL_DIR/prosody-modules/mod_csi/*.lua /usr/lib/prosody/modules
  74. fi
  75. # XEP-0280 Message Carbons
  76. # Ensures all messages get delivered to all clients (if you have a mobile and desktop client)
  77. if [ -d $INSTALL_DIR/prosody-modules/mod_carbons ]; then
  78. cp $INSTALL_DIR/prosody-modules/mod_carbons/*.lua /usr/lib/prosody/modules
  79. fi
  80. # XEP-0198 Stream management
  81. # Helps mobile apps recover when a device switches networks.
  82. if [ -d $INSTALL_DIR/prosody-modules/mod_smacks ]; then
  83. cp $INSTALL_DIR/prosody-modules/mod_smacks/*.lua /usr/lib/prosody/modules
  84. fi
  85. if [ -d $INSTALL_DIR/prosody-modules/mod_smacks_offline ]; then
  86. cp $INSTALL_DIR/prosody-modules/mod_smacks_offline/*.lua /usr/lib/prosody/modules
  87. fi
  88. # XEP-0191: blocking
  89. if [ -d $INSTALL_DIR/prosody-modules/mod_blocking ]; then
  90. cp $INSTALL_DIR/prosody-modules/mod_blocking/*.lua /usr/lib/prosody/modules
  91. fi
  92. # XEP-0016 Privacy lists
  93. if [ -d $INSTALL_DIR/prosody-modules/mod_privacy_lists ]; then
  94. cp $INSTALL_DIR/prosody-modules/mod_privacy_lists/*.lua /usr/lib/prosody/modules
  95. fi
  96. # If offline then send messages to email
  97. if [ -d $INSTALL_DIR/prosody-modules/mod_offline_email ]; then
  98. cp $INSTALL_DIR/prosody-modules/mod_offline_email/*.lua /usr/lib/prosody/modules
  99. fi
  100. }
  101. function upgrade_xmpp {
  102. function_check update_prosody_modules
  103. update_prosody_modules
  104. }
  105. function backup_local_xmpp {
  106. source_directory=/var/lib/prosody xmpp
  107. if [ -d $source_directory ]; then
  108. dest_directory=xmpp
  109. echo $"Backing up $source_directory to $dest_directory"
  110. function_check backup_directory_to_usb
  111. backup_directory_to_usb $source_directory $dest_directory
  112. echo $"Backup to $dest_directory complete"
  113. fi
  114. }
  115. function restore_local_xmpp {
  116. if [ -d /var/lib/prosody ]; then
  117. echo $"Restoring xmpp settings"
  118. temp_restore_dir=/root/tempxmpp
  119. function_check restore_directory_from_usb
  120. restore_directory_from_usb $temp_restore_dir xmpp
  121. cp -r $temp_restore_dir/var/lib/prosody/* /var/lib/prosody
  122. if [ ! "$?" = "0" ]; then
  123. function_check set_user_permissions
  124. set_user_permissions
  125. function_check backup_unmount_drive
  126. backup_unmount_drive
  127. exit 725
  128. fi
  129. rm -rf $temp_restore_dir
  130. service prosody restart
  131. chown -R prosody:prosody /var/lib/prosody/*
  132. echo $"Restore of xmpp settings complete"
  133. fi
  134. }
  135. function backup_remote_xmpp {
  136. if [ -d /var/lib/prosody ]; then
  137. echo $"Backing up the xmpp settings"
  138. backup_directory_to_friend /var/lib/prosody xmpp
  139. echo $"Backup of xmpp settings complete"
  140. fi
  141. }
  142. function restore_remote_xmpp {
  143. if [ -d /var/lib/prosody ]; then
  144. echo $"Restoring xmpp settings"
  145. temp_restore_dir=/root/tempxmpp
  146. function_check restore_directory_from_friend
  147. restore_directory_from_friend $temp_restore_dir xmpp
  148. cp -r $temp_restore_dir/var/lib/prosody/* /var/lib/prosody
  149. if [ ! "$?" = "0" ]; then
  150. exit 725
  151. fi
  152. rm -rf $temp_restore_dir
  153. service prosody restart
  154. chown -R prosody:prosody /var/lib/prosody/*
  155. echo $"Restore of xmpp settings complete"
  156. fi
  157. }
  158. function configure_firewall_for_xmpp {
  159. if [ ! -d /etc/prosody ]; then
  160. return
  161. fi
  162. if grep -Fxq "configure_firewall_for_xmpp" $COMPLETION_FILE; then
  163. return
  164. fi
  165. if [[ $INSTALLED_WITHIN_DOCKER == "yes" ]]; then
  166. # docker does its own firewalling
  167. return
  168. fi
  169. if [[ $ONION_ONLY != "no" ]]; then
  170. return
  171. fi
  172. iptables -A INPUT -p tcp --dport 5222:5223 -j ACCEPT
  173. iptables -A INPUT -p tcp --dport 5269 -j ACCEPT
  174. iptables -A INPUT -p tcp --dport 5280:5281 -j ACCEPT
  175. function_check save_firewall_settings
  176. save_firewall_settings
  177. OPEN_PORTS+=('XMPP 5222-5223')
  178. OPEN_PORTS+=('XMPP 5269')
  179. OPEN_PORTS+=('XMPP 5280-5281')
  180. echo 'configure_firewall_for_xmpp' >> $COMPLETION_FILE
  181. }
  182. function remove_xmpp_client {
  183. if [[ $(app_is_installed xmpp_client) == "0" ]]; then
  184. return
  185. fi
  186. apt-get -y remove --purge profanity
  187. sed '/install_xmpp_client/d' $COMPLETION_FILE
  188. }
  189. function remove_xmpp {
  190. remove_xmpp_client
  191. if [[ $(app_is_installed xmpp) == "0" ]]; then
  192. return
  193. fi
  194. iptables -D INPUT -p tcp --dport 5222:5223 -j ACCEPT
  195. iptables -D INPUT -p tcp --dport 5269 -j ACCEPT
  196. iptables -D INPUT -p tcp --dport 5280:5281 -j ACCEPT
  197. function_check save_firewall_settings
  198. save_firewall_settings
  199. function_check remove_onion_service
  200. remove_onion_service xmpp 5222 5223 5269
  201. apt-get -y remove --purge prosody prosody-modules
  202. if [ -d $INSTALL_DIR/prosody-modules ]; then
  203. rm -rf $INSTALL_DIR/prosody-modules
  204. fi
  205. if [ -d /etc/prosody ]; then
  206. rm -rf /etc/prosody
  207. fi
  208. sed '/install_xmpp/d' $COMPLETION_FILE
  209. sed '/xmpp /d' $COMPLETION_FILE
  210. }
  211. function xmpp_email_headers {
  212. for d in /home/*/ ; do
  213. USERNAME=$(echo "$d" | awk -F '/' '{print $3}')
  214. if [[ $(is_valid_user "$USERNAME") == "1" ]]; then
  215. if [ -f /home/$USERNAME/.muttrc ]; then
  216. if ! grep -q "Jabber-ID" /home/$USERNAME/.muttrc; then
  217. echo "my_hdr Jabber-ID: ${USERNAME}@${HOSTNAME}" >> /home/$USERNAME/.muttrc
  218. fi
  219. fi
  220. fi
  221. done
  222. }
  223. function install_xmpp_main {
  224. update_prosody_modules
  225. if [[ $(app_is_installed xmpp_main) == "1" ]]; then
  226. return
  227. fi
  228. apt-get -y install lua-sec lua-bitop
  229. apt-get -y install prosody prosody-modules mercurial
  230. if [ ! -d /etc/prosody ]; then
  231. echo $"ERROR: prosody does not appear to have installed. $CHECK_MESSAGE"
  232. exit 52
  233. fi
  234. # obtain the prosody modules
  235. cd $INSTALL_DIR
  236. hg clone https://hg.prosody.im/prosody-modules/ prosody-modules
  237. if [ ! -d $INSTALL_DIR/prosody-modules/mod_onions ]; then
  238. echo $'mod_onions prosody module could not be found'
  239. exit 73254
  240. fi
  241. # install the onions module
  242. update_prosody_modules
  243. if [ ! -f /usr/lib/prosody/modules/mod_onions.lua ]; then
  244. echo $'mod_onions.lua could not be copied to the prosody modules directory'
  245. exit 63952
  246. fi
  247. # create a certificate
  248. if [ ! -f /etc/ssl/certs/xmpp.dhparam ]; then
  249. ${PROJECT_NAME}-addcert -h xmpp --dhkey $DH_KEYLENGTH
  250. check_certificates xmpp
  251. fi
  252. chown prosody:prosody /etc/ssl/private/xmpp.key
  253. chown prosody:prosody /etc/ssl/certs/xmpp.*
  254. cp -a /etc/prosody/conf.avail/example.com.cfg.lua /etc/prosody/conf.avail/xmpp.cfg.lua
  255. sed -i 's|/etc/prosody/certs/example.com.key|/etc/ssl/private/xmpp.key|g' /etc/prosody/conf.avail/xmpp.cfg.lua
  256. sed -i 's|/etc/prosody/certs/example.com.crt|/etc/ssl/certs/xmpp.crt|g' /etc/prosody/conf.avail/xmpp.cfg.lua
  257. if ! grep -q "xmpp.dhparam" /etc/prosody/conf.avail/xmpp.cfg.lua; then
  258. sed -i '/certificate =/a\ dhparam = "/etc/ssl/certs/xmpp.dhparam";' /etc/prosody/conf.avail/xmpp.cfg.lua
  259. fi
  260. if ! grep -q 'options = {"no_sslv2", "no_sslv3" }' /etc/prosody/conf.avail/xmpp.cfg.lua; then
  261. sed -i '/certificate =/a\ options = {"no_sslv2", "no_sslv3" };' /etc/prosody/conf.avail/xmpp.cfg.lua
  262. fi
  263. if ! grep -q 'ciphers =' /etc/prosody/conf.avail/xmpp.cfg.lua; then
  264. sed -i "/certificate =/a\ ciphers = $XMPP_CIPHERS;" /etc/prosody/conf.avail/xmpp.cfg.lua
  265. fi
  266. if ! grep -q 'depth = "1";' /etc/prosody/conf.avail/xmpp.cfg.lua; then
  267. sed -i '/certificate =/a\ depth = "1";' /etc/prosody/conf.avail/xmpp.cfg.lua
  268. fi
  269. if ! grep -q 'curve =' /etc/prosody/conf.avail/xmpp.cfg.lua; then
  270. sed -i "/certificate =/a\ curve = $XMPP_ECC_CURVE;" /etc/prosody/conf.avail/xmpp.cfg.lua
  271. fi
  272. sed -i "s/example.com/$DEFAULT_DOMAIN_NAME/g" /etc/prosody/conf.avail/xmpp.cfg.lua
  273. sed -i 's/enabled = false -- Remove this line to enable this host//g' /etc/prosody/conf.avail/xmpp.cfg.lua
  274. if ! grep -q "modules_enabled" /etc/prosody/conf.avail/xmpp.cfg.lua; then
  275. echo '' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  276. echo 'modules_enabled = {' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  277. echo ' "bosh"; -- Enable mod_bosh' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  278. echo ' "tls"; -- Enable mod_tls' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  279. echo ' "saslauth"; -- Enable mod_saslauth' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  280. echo ' "onions"; -- Enable chat via onion service' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  281. echo ' "mam"; -- Message archive management' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  282. echo ' "csi"; -- Client state indication' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  283. echo ' "carbons"; -- Message carbons' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  284. echo ' "smacks"; -- Stream management' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  285. echo ' "smacks_offline"; -- Stream management' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  286. echo ' "pep"; -- Personal Eventing Protocol (to support OMEMO)' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  287. echo ' "privacy"; -- Privacy lists' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  288. echo ' "privacy_lists"; -- Privacy lists' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  289. echo ' "blocking"; -- Blocking command' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  290. echo ' "roster"; -- Roster versioning' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  291. echo ' "offline_email"; -- If offline send to email' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  292. echo '}' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  293. echo '' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  294. echo 'c2s_require_encryption = true' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  295. echo 's2s_require_encryption = true' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  296. echo 'allow_unencrypted_plain_auth = false' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  297. fi
  298. ln -sf /etc/prosody/conf.avail/xmpp.cfg.lua /etc/prosody/conf.d/xmpp.cfg.lua
  299. sed -i 's|/etc/prosody/certs/localhost.key|/etc/ssl/private/xmpp.key|g' /etc/prosody/prosody.cfg.lua
  300. sed -i 's|/etc/prosody/certs/localhost.crt|/etc/ssl/certs/xmpp.crt|g' /etc/prosody/prosody.cfg.lua
  301. if ! grep -q "xmpp.dhparam" /etc/prosody/prosody.cfg.lua; then
  302. sed -i '/certificate =/a\ dhparam = "/etc/ssl/certs/xmpp.dhparam";' /etc/prosody/prosody.cfg.lua
  303. fi
  304. if ! grep -q 'options = {"no_sslv2", "no_sslv3" }' /etc/prosody/prosody.cfg.lua; then
  305. sed -i '/certificate =/a\ options = {"no_sslv2", "no_sslv3" };' /etc/prosody/prosody.cfg.lua
  306. fi
  307. if ! grep -q 'ciphers =' /etc/prosody/prosody.cfg.lua; then
  308. sed -i "/certificate =/a\ ciphers = $XMPP_CIPHERS;" /etc/prosody/prosody.cfg.lua
  309. fi
  310. if ! grep -q 'depth = "1";' /etc/prosody/prosody.cfg.lua; then
  311. sed -i '/certificate =/a\ depth = "1";' /etc/prosody/prosody.cfg.lua
  312. fi
  313. if ! grep -q 'curve =' /etc/prosody/prosody.cfg.lua; then
  314. sed -i "/certificate =/a\ curve = $XMPP_ECC_CURVE;" /etc/prosody/prosody.cfg.lua
  315. fi
  316. sed -i 's/c2s_require_encryption = false/c2s_require_encryption = true/g' /etc/prosody/prosody.cfg.lua
  317. if ! grep -q "s2s_require_encryption" /etc/prosody/prosody.cfg.lua; then
  318. sed -i '/c2s_require_encryption/a\s2s_require_encryption = true' /etc/prosody/prosody.cfg.lua
  319. fi
  320. if ! grep -q "allow_unencrypted_plain_auth" /etc/prosody/prosody.cfg.lua; then
  321. echo 'allow_unencrypted_plain_auth = false' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  322. fi
  323. sed -i 's/--"bosh";/"bosh";/g' /etc/prosody/prosody.cfg.lua
  324. sed -i 's/authentication = "internal_plain"/authentication = "internal_hashed"/g' /etc/prosody/prosody.cfg.lua
  325. sed -i 's/enabled = false -- Remove this line to enable this host//g' /etc/prosody/prosody.cfg.lua
  326. sed -i 's|key = "/etc/prosody/certs/example.com.key"|key = "/etc/ssl/private/xmpp.key"|g' /etc/prosody/prosody.cfg.lua
  327. sed -i 's|certificate = "/etc/prosody/certs/example.com.crt"|certificate = "/etc/ssl/certs/xmpp.crt"|g' /etc/prosody/prosody.cfg.lua
  328. sed -i "s/example.com/$DEFAULT_DOMAIN_NAME/g" /etc/prosody/prosody.cfg.lua
  329. systemctl restart prosody
  330. touch /home/$MY_USERNAME/README
  331. if [ ! -d /var/lib/tor ]; then
  332. echo $'No Tor installation found. xmpp onion site cannot be configured.'
  333. exit 877367
  334. fi
  335. if ! grep -q "hidden_service_xmpp" /etc/tor/torrc; then
  336. echo 'HiddenServiceDir /var/lib/tor/hidden_service_xmpp/' >> /etc/tor/torrc
  337. echo "HiddenServicePort 5222 127.0.0.1:5222" >> /etc/tor/torrc
  338. echo "HiddenServicePort 5269 127.0.0.1:5269" >> /etc/tor/torrc
  339. echo $'Added onion site for xmpp chat'
  340. fi
  341. systemctl restart tor
  342. wait_for_onion_service 'xmpp'
  343. if [ ! -f /var/lib/tor/hidden_service_xmpp/hostname ]; then
  344. echo $'xmpp onion site hostname not found'
  345. exit 65349
  346. fi
  347. XMPP_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_xmpp/hostname)
  348. if ! grep -q "${XMPP_ONION_HOSTNAME}" /etc/prosody/conf.avail/xmpp.cfg.lua; then
  349. echo '' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  350. echo "VirtualHost \"${XMPP_ONION_HOSTNAME}\"" >> /etc/prosody/conf.avail/xmpp.cfg.lua
  351. echo ' modules_enabled = { "onions" };' >> /etc/prosody/conf.avail/xmpp.cfg.lua
  352. fi
  353. if ! grep -q "xmpp onion domain" $COMPLETION_FILE; then
  354. echo "xmpp onion domain:${XMPP_ONION_HOSTNAME}" >> $COMPLETION_FILE
  355. else
  356. sed -i "s|xmpp onion domain.*|xmpp onion domain:${XMPP_ONION_HOSTNAME}|g" $COMPLETION_FILE
  357. fi
  358. if ! grep -q "Your xmpp password is" /home/$MY_USERNAME/README; then
  359. if [ ${#XMPP_PASSWORD} -lt 8 ]; then
  360. if [ -f $IMAGE_PASSWORD_FILE ]; then
  361. XMPP_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  362. else
  363. XMPP_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  364. fi
  365. fi
  366. prosodyctl register $MY_USERNAME $DEFAULT_DOMAIN_NAME $XMPP_PASSWORD
  367. echo '' >> /home/$MY_USERNAME/README
  368. echo '' >> /home/$MY_USERNAME/README
  369. echo $'XMPP' >> /home/$MY_USERNAME/README
  370. echo '====' >> /home/$MY_USERNAME/README
  371. echo $"XMPP onion domain: ${XMPP_ONION_HOSTNAME}" >> /home/$MY_USERNAME/README
  372. echo $"Your XMPP password is: $XMPP_PASSWORD" >> /home/$MY_USERNAME/README
  373. echo $'You can change it with: ' >> /home/$MY_USERNAME/README
  374. echo '' >> /home/$MY_USERNAME/README
  375. echo " prosodyctl passwd $MY_EMAIL_ADDRESS" >> /home/$MY_USERNAME/README
  376. chown $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/README
  377. chmod 600 /home/$MY_USERNAME/README
  378. fi
  379. function_check configure_firewall_for_xmpp
  380. configure_firewall_for_xmpp
  381. xmpp_email_headers
  382. install_completed xmpp_main
  383. }
  384. function install_xmpp_client {
  385. if [[ $(app_is_installed xmpp_client) == "1" ]]; then
  386. return
  387. fi
  388. apt-get -y install profanity
  389. XMPP_CLIENT_DIR=/home/$MY_USERNAME/.local/share/profanity
  390. XMPP_CLIENT_ACCOUNTS=$XMPP_CLIENT_DIR/accounts
  391. if [ ! -d $XMPP_CLIENT_DIR ]; then
  392. mkdir -p $XMPP_CLIENT_DIR
  393. fi
  394. if [[ $ONION_ONLY == 'no' ]]; then
  395. echo "[${MY_USERNAME}@${DEFAULT_DOMAIN_NAME}]" > $XMPP_CLIENT_ACCOUNTS
  396. echo 'enabled=true' >> $XMPP_CLIENT_ACCOUNTS
  397. echo "jid=${MY_USERNAME}@${DEFAULT_DOMAIN_NAME}" >> $XMPP_CLIENT_ACCOUNTS
  398. echo 'resource=profanity' >> $XMPP_CLIENT_ACCOUNTS
  399. echo "muc.service=conference.${DEFAULT_DOMAIN_NAME}" >> $XMPP_CLIENT_ACCOUNTS
  400. echo "muc.nick=${MY_USERNAME}" >> $XMPP_CLIENT_ACCOUNTS
  401. echo 'presence.last=online' >> $XMPP_CLIENT_ACCOUNTS
  402. echo 'presence.login=online' >> $XMPP_CLIENT_ACCOUNTS
  403. echo 'priority.online=0' >> $XMPP_CLIENT_ACCOUNTS
  404. echo 'priority.chat=0' >> $XMPP_CLIENT_ACCOUNTS
  405. echo 'priority.away=0' >> $XMPP_CLIENT_ACCOUNTS
  406. echo 'priority.xa=0' >> $XMPP_CLIENT_ACCOUNTS
  407. echo 'priority.dnd=0' >> $XMPP_CLIENT_ACCOUNTS
  408. if [ ${#XMPP_PASSWORD} -gt 2 ]; then
  409. echo "password=$XMPP_PASSWORD" >> $XMPP_CLIENT_ACCOUNTS
  410. fi
  411. fi
  412. if [ -f /var/lib/tor/hidden_service_xmpp/hostname ]; then
  413. XMPP_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_xmpp/hostname)
  414. echo "[${MY_USERNAME}@${XMPP_ONION_HOSTNAME}]" >> $XMPP_CLIENT_ACCOUNTS
  415. if [[ $ONION_ONLY == 'no' ]]; then
  416. echo 'enabled=false' >> $XMPP_CLIENT_ACCOUNTS
  417. else
  418. echo 'enabled=true' >> $XMPP_CLIENT_ACCOUNTS
  419. fi
  420. echo "jid=${MY_USERNAME}@${XMPP_ONION_HOSTNAME}" >> $XMPP_CLIENT_ACCOUNTS
  421. echo 'resource=profanity' >> $XMPP_CLIENT_ACCOUNTS
  422. echo "muc.service=conference.${XMPP_ONION_HOSTNAME}" >> $XMPP_CLIENT_ACCOUNTS
  423. echo "muc.nick=${MY_USERNAME}" >> $XMPP_CLIENT_ACCOUNTS
  424. echo 'presence.last=online' >> $XMPP_CLIENT_ACCOUNTS
  425. echo 'presence.login=online' >> $XMPP_CLIENT_ACCOUNTS
  426. echo 'priority.online=0' >> $XMPP_CLIENT_ACCOUNTS
  427. echo 'priority.chat=0' >> $XMPP_CLIENT_ACCOUNTS
  428. echo 'priority.away=0' >> $XMPP_CLIENT_ACCOUNTS
  429. echo 'priority.xa=0' >> $XMPP_CLIENT_ACCOUNTS
  430. echo 'priority.dnd=0' >> $XMPP_CLIENT_ACCOUNTS
  431. if [ ${#XMPP_PASSWORD} -gt 2 ]; then
  432. echo "password=$XMPP_PASSWORD" >> $XMPP_CLIENT_ACCOUNTS
  433. fi
  434. fi
  435. if [ ! -d /home/$MY_USERNAME/.config/profanity ]; then
  436. mkdir /home/$MY_USERNAME/.config/profanity
  437. fi
  438. echo '[connection]' > /home/$MY_USERNAME/.config/profanity/profrc
  439. echo "account=${MY_USERNAME}@${DEFAULT_DOMAIN_NAME}" >> /home/$MY_USERNAME/.config/profanity/profrc
  440. chown -R $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/.local
  441. chown -R $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/.config
  442. install_completed xmpp_client
  443. }
  444. function install_xmpp {
  445. install_xmpp_main
  446. install_xmpp_client
  447. }
  448. # NOTE: deliberately no exit 0